#include <sicstus/sicstus.h>
#include <stdio.h>

/* we initialize and restore `by hand', using this main.c file,
 * rather than using the command `spld fsa.sav'. The reason is that
 * in that case we don't know where to find fsa.sav if the program
 * is started from a different directory. Here, we assume the name
 * of the saved state is given as the first argument. The remaining
 * arguments are visible to the rest of the program (i.e. we skip
 * the first argument (name of program) and second argument (name of
 * saved state)).
 */

int user_main(int argc, char *argv[]) {
  SP_term_ref start;

  if (SP_initialize(argc-2,&argv[2],NULL)==SP_ERROR) 
    {
      fprintf(stderr,"SP_initialize: error: %s\n",SP_error_message(SP_errno));
    }

  if (SP_restore(argv[1])==SP_ERROR)
    {
      fprintf(stderr,"SP_restore: error: %s\n",SP_error_message(SP_errno));
    }

  return 0;
}
